
#ifndef __displayManager__
#define __displayManager__

#include <yarp/os/Port.h>
#include <yarp/sig/Image.h>

#include <string>


/*
 * a simple class displaying the memory images 
 * on a yarpview window. 
 */
class displayManager 
{
protected:
    yarp::os::Port p;
    yarp::sig::ImageOf<yarp::sig::PixelMono> img;
    int maxAddr;

public:
    displayManager(const std::string portName);
    ~displayManager();

    /**
     * set()
     * - keeps the internal memory image up-to-date 
     */
    void set(const unsigned int addr, unsigned char val);

    /**
     * snapshot()
     * - sends out the internal memory image to a yarpview window
     */
    void snapshot();
};

#endif
