
#include <displayManager.h>

using namespace yarp;
using namespace yarp::os;
using namespace yarp::sig;
using namespace std;


displayManager::displayManager(const string portName)
{
    p.open(portName.c_str());

    img.resize(320,240);
    img.zero();

    maxAddr=img.width()*img.height();
}


displayManager::~displayManager()
{
    p.interrupt();
    p.close();
}


void displayManager::set(const unsigned int addr, unsigned char val)
{
    if (int(addr)<maxAddr)
    {
        int y=addr/img.width();
        int x=addr-y*img.width();
    
        img.pixel(x,y)=val;
    }
}


void displayManager::snapshot()
{
    p.write(img);
}


