/*
 * A new Yarp application!.
 */

#include <iostream>
#include <stdlib.h>

#include <yarp/os/Network.h>
#include <processManager.h>

/*
 * namespaces.
 */
using namespace yarp::os;
using namespace std;


/*
 * simple example of the use of the memory simulator.
 */
int main()
{
    Network yarp;

    // define the memory management unit
    // with a R-clearing rate of 50 ms
    memoryManager  mmu(50);

    // define the thread running each 5 ms,
    // dumping memory images each 100 ms
    // and addressing the paged memory through the mmu
    processManager thr(5,100,mmu);

    mmu.start();
    thr.start();

    // wait until a key is pressed
    char ch;
    scanf("%c",&ch);

    // Once you launched the thread, in order to keep track
    // of the proccess do the following:
    // 
    // on terminal 1 launch the yarp server:   type 'yarpserver'
    // on terminal 2 launch the first viewer:  type 'yarpview /memView1'
    // on terminal 3 launch the second viewer: type 'yarpview /memView2'
    // on terminal 4 connect:                  type 'yarp connect /mmu /memView1'
    // on terminal 5 connect:                  type 'yarp connect /phy /memView2'
    // 
    // the resulting two images shall correspond each other while evolving.

    thr.stop();
    mmu.stop();
    
    return 0;
}

